import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class EigenUsedLR extends Frame
{  public int Iter;
   public EigenUsedLR()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double [] MultMV(double [][] A,double [] B, int N1,int N2)
   {  int i,j,k;
      double [] C = new double[N1];
      for(i=0;i<N1;i++)
      {  C[i]=0.0;
         for(k=0;k<N2;k++) C[i] += A[i][k] * B[k];
      }
      return C;
   }
   public double [][] MultM(double [][] A,double [][] B, int N1,int N2,int N3)
   {  int i,j,k;
      double [][] C = new double[N1][N3];
      for(i = 0; i < N1; i++)for(j = 0; j < N3;j++)
      {  C[i][j]=0.0; for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
      return C;
   }
   public void MoveMat(double [][] A, double[][] B, int N, int COL)
   {
      int i,j;
      for(i = 0; i < N; i++)for(j=0; j<N; j++) B[i][j] = A[i][j + COL]; 
   }
   public int InvMat(double [][] A, int N, double Eps)
   {   int i,j,k; double Alfa;int N2 = N * 2;    
       for(i=0;i<N;i++)for(j=0;j<N;j++) A[i][j+N] = (i==j ? 1 : 0);
       for(k = 0; k < N; k++)       
       { if(Math.abs(A[k][k]) < Eps) return 1;
         Alfa=1/A[k][k];int k1=k+1;
         for(j=k1;j<N2;j++) A[k][j] *= Alfa;
         for(i=0;i<N;i++)
            if(i != k)
            { Alfa=A[i][k];
              for(j=k1;j<N2;j++) A[i][j] -= Alfa* A[k][j];
            }
       } 
       return 0;
   }
   public void LU_D(double [][] A,double [][] L,double [][] U,int N)
   {  int i, j, k; double T;
      for(i = 0; i < N; i++) for(j = 0; j < N; j++) L[i][j] = U[i][j] = 0;
      L[0][0] = 1;
      for(j = 0; j < N; j++) U[0][j] = A[0][j]    ;
      for(i = 1; i < N; i++)
      {  U[i][0] = L[0][i] = 0;  L[i][0] = A[i][0] / U[0][0];
      }
      for(i = 1; i < N; i++)
      {
        L[i][i] = 1; T = A[i][i];
        for(k=0; k<=i; k++) T -= L[i][k] * U[k][i];
        U[i][i] = T;
        for(j=i+1; j < N; j++)
        {   U[j][i] = L[i][j] = 0;
            T = A[j][i];
            for(k = 0; k <= i; k++) T -= L[j][k] * U[k][i];
            L[j][i] = T / U[i][i];
            T = A[i][j];
            for(k = 0; k <= i; k++) T -= L[i][k] * U[k][j];
            U[i][j] = T;
         }
       }
   }
   public double [] MultSV(double A, double [] B, int N)
   {  int i,j,k;
      double [] C = new double[N];
      for(i = 0; i < N; i++) C[i] = A * B[i];
      return C;
   }
   public double[][] EigenValue(double [][] A, double EPS, int iterMax, int N)
   {  int i, j;
      double [][] L = new double[N][N];
      double [][] U = new double[N][N];
      double [][] AA = A;
      int  R = 0;  double E = EPS * 100; double E2 = EPS * EPS;
      while( Iter < iterMax && E > E2)
      { Iter++;
        LU_D(AA, L, U, N);
        AA = MultM(U, L, N, N, N);
        E = 0; for(i = 1; i < N; i++) for(j = 0; j <= i - 1; j++) E += AA[i][j] * AA[i][j];
      }
      return AA;
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  double DN = 10 * Math.pow(10.0,(double)(N-1));
      double DX =  D * DN; if(Math.abs(DX)<0.5)return 0;
      return Math.rint(DX)/DN;
   }
   public void DrawData(Graphics g, int Y, double [][] A,int N)
   {  int i, j;
      for(i=0;i<N;i++)
      {
         for(j=0;j<N; j++)
         {  g.drawString( "" + round(A[i][j],3), 50 + j * 50,Y + i * 20);
         }
      }
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A  = {{4,2,1,3},{2,3,1,2},{1,1,2,1},{3,2,1,1}};
      setTitle("LRɂ镡ŗLl");
      g.drawString( "f[^",20,50);
      DrawData(g, 80, A, 4);
      double [][]AA = EigenValue(A, 0.00001, 100, 4);
      g.drawString( "mF (JԂ : " + Iter + ") ΊpvfŗLl" , 20, 170);
      DrawData(g, 200, AA, 4);
   } 
   public static void main(String[] args)
   {  Frame w = new EigenUsedLR();
      w.setVisible(true);
   }
}
